/**
 * @file Memsic2125Test.c Accelerometer library simple test.
 * To do a more complicated test like Beau's requires a graphics
 * driver which doesn't exist in C yet.
 * Copyright (c) 2009, Steve Denson
 * See end of file for MIT license terms.
 */
#include <stdio.h>
#include <propeller.h>
#include "tv_text.h"
#include "Memsic2125.h"

#define XPIN 0
#define YPIN 1

void main(void)
{
    int xpulse;
    int ypulse;
    int xcycle;
    int ycycle;
    
    tvText_start(12);  // start TV
    tvText_setXY(0,1);
    printf("Simple Memsic2125 Test");

    while(1) {
        xcycle = m2125_getCycle(XPIN);
        ycycle = m2125_getCycle(YPIN);
        xpulse= m2125_getPulse(XPIN);
        ypulse= m2125_getPulse(YPIN);
        tvText_setXY(1,3);
        printf("X,Y Pulse %d  %d ", xpulse, ypulse);
        tvText_setXY(1,4);
        printf("X,Y Cycle %d %d ", xcycle, ycycle);
        tvText_setXY(1,6);
        printf("X,Y Ratios ");
        printf("%d %d        ", xpulse*1000/xcycle-500, ypulse*1000/ycycle-500);
	}
}

/*
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
*/