	.area text(rom,rel)
	.dbfile ..\..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Memsic2125\Memsic2125.c
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Memsic2125\Memsic2125.c
	.dbfunc e m2125_getPulse _m2125_getPulse fI
;             rc -> R4
;             t1 -> R7
;             t0 -> R6
;           mask -> R5
;            pin -> R6
_m2125_getPulse::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R6,R0	
	.dbline -1
	.dbline 14
; /**
;  * @file Memsic2125.c Accelerometer implementation file
;  * Copyright (c) 2009, Steve Denson
;  * See end of file for MIT license terms.
;  */
; #include <propeller.h>
; #include "Memsic2125.h"
; 
; /**
;  * Get output pulse time
;  * See header for api details.
;  */
; int m2125_getPulse(int pin)
; {
	.dbline 15
;     int rc = 0;
	mov R4,#0	
	.dbline 17
;     int t0, t1;
;     int mask = 1 << pin;
	mov R5,#1	
	shl R5,R6	
	.dbline 18
;     asm("waitpne %mask, %mask");  // Wait For Pin To Go LOW
	waitpne R5, R5
	.dbline 19
;     asm("waitpeq %mask, %mask");  // Wait For Pin To Go HIGH
	waitpeq R5, R5
	.dbline 20
;     t0 = CNT;                     // Store Current Counter Value
	mov R15,0x1f1
	mov R6,R15	
	.dbline 21
;     asm("waitpne %mask, %mask");  // Wait For Pin To Go LOW 
	waitpne R5, R5
	.dbline 22
;     t1 = CNT;                     // Store New Counter Value
	mov R15,0x1f1
	mov R7,R15	
	.dbline 23
;     rc = (ABS(t1 - t0) / (CLKFREQ / 2000000)) >> 1;
	sub R15,R6	WC
IF_AE	add PC,#16	;Jump to L3
	neg R15,R7	
	mov R5,R15	
	sub R5,R6	
	add PC,#8	;Jump to L4
L3:
	mov R5,R7	
	sub R5,R6	
L4:
	@FLDCNST	
	.long 2000000	
	mov R1,TEMP0	
	rdlong R0,#0	
	@FDIV32S	
	mov R1,R0	
	mov R0,R5	
	@FDIV32S	
	mov R15,R0	
	mov R4,R0	
	sar R4,#1	
	.dbline 24
;     return rc;  // Return Time in s
	mov R0,R4	
	.dbline -2
L1:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r rc 4 I
	.dbsym r t1 7 I
	.dbsym r t0 6 I
	.dbsym r mask 5 I
	.dbsym r pin 6 I
	.dbend
	.dbfunc e m2125_getCycle _m2125_getCycle fI
;             rc -> R4
;             t1 -> R7
;             t0 -> R6
;           mask -> R5
;            pin -> R6
_m2125_getCycle::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R6,R0	
	.dbline -1
	.dbline 32
; }
; 
; /**
;  * Get output cycle time
;  * See header for api details.
;  */
; int m2125_getCycle(int pin)
; {
	.dbline 33
;     int rc = 0;
	mov R4,#0	
	.dbline 35
;     int t0, t1;
;     int mask = 1 << pin;
	mov R5,#1	
	shl R5,R6	
	.dbline 36
;     asm("waitpeq %mask, %mask");  // Wait For Pin To Go HIGH
	waitpeq R5, R5
	.dbline 37
;     asm("waitpne %mask, %mask");  // Wait For Pin To Go LOW
	waitpne R5, R5
	.dbline 38
;     t0 = CNT;                     // Store Current Counter Value
	mov R15,0x1f1
	mov R6,R15	
	.dbline 39
;     asm("waitpeq %mask, %mask");  // Wait For Pin To Go HIGH
	waitpeq R5, R5
	.dbline 40
;     asm("waitpne %mask, %mask");  // Wait For Pin To Go LOW 
	waitpne R5, R5
	.dbline 41
;     t1 = CNT;                     // Store New Counter Value
	mov R15,0x1f1
	mov R7,R15	
	.dbline 42
;     rc = (ABS(t1 - t0) / (CLKFREQ / 2000000)) >> 1;
	sub R15,R6	WC
IF_AE	add PC,#16	;Jump to L7
	neg R15,R7	
	mov R5,R15	
	sub R5,R6	
	add PC,#8	;Jump to L8
L7:
	mov R5,R7	
	sub R5,R6	
L8:
	@FLDCNST	
	.long 2000000	
	mov R1,TEMP0	
	rdlong R0,#0	
	@FDIV32S	
	mov R1,R0	
	mov R0,R5	
	@FDIV32S	
	mov R15,R0	
	mov R4,R0	
	sar R4,#1	
	.dbline 43
;     return rc;  // Return Time in s
	mov R0,R4	
	.dbline -2
L5:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r rc 4 I
	.dbsym r t1 7 I
	.dbsym r t0 6 I
	.dbsym r mask 5 I
	.dbsym r pin 6 I
	.dbend
